<template>
  <div class="metrocheck-player">
    <v-row no-gutters>
      <v-slider
        v-if="hydrated"
        :value="sliderTime"
        :hide-details="true"
        min="0"
        :max="24 * 60"
        @change="handleTimesliderChange"
      >
        <template v-slot:prepend>
          00:00
        </template>
        <template v-slot:append>
          23:59
        </template>
      </v-slider>
    </v-row>

    <v-row
      no-gutters
      class="player--controls-container d-flex"
    >
      <v-col
        cols="6"
        class="d-flex"
      >
        <v-btn
          icon
          @click="() => tick(-1)"
        >
          <v-icon>mdi-skip-backward</v-icon>
        </v-btn>

        <v-btn
          v-if="isPlaying"
          icon
        >
          <v-icon>
            mdi-pause
          </v-icon>
        </v-btn>
        <v-btn
          v-else
          icon
        >
          <v-icon>
            mdi-play
          </v-icon>
        </v-btn>

        <v-btn
          icon
          @click="() => tick(1)"
        >
          <v-icon>mdi-skip-forward</v-icon>
        </v-btn>
      </v-col>
      <v-col class="col">
        <v-text-field
          v-model="playSpeed"
          append-icon="mdi-plus"
          prepend-icon="mdi-minus"
          :hide-details="true"
          counter="1"
          :dense="true"
          label="speed"
          outlined
          @click:append="() => tickPlaySpeed(1)"
          @click:prepend="() => tickPlaySpeed(-1)"
        />
      </v-col>
    </v-row>
  </div>
</template>

<script>
  import { mapState } from 'vuex'
  import moment from 'moment-timezone'
  import { mutations } from '../store/constants'

  export default {
    name: 'MetrocheckPlayer',

    data: function () {
      return {
        playSpeed: 1,
        isPlaying: false,
      }
    },

    computed: {
      ...mapState(['displayedDatetime', 'hydrated']),

      sliderTime: {
        get: function () { return moment(this.displayedDatetime).clone().format('HHmm') },
        set: function (val) {
          console.log('sliderTime setter called with', val)
          const dateAtMidnight = moment(this.displayedDatetime).clone().set({ hours: 0, minutes: 0, seconds: 0 })
          this.$store.commit(mutations.SET_DISPLAYED_DATETIME, dateAtMidnight.add(val, 'minutes').valueOf())
        },
      },

      /**
       * @todo: should probably be stored elsewhere
       * @return {number}
       */
      SPEED_TICK: function () { return 1 },
    },

    methods: {

      handleTimesliderChange: function (value) {
        this.sliderTime = value
      },

      /**
       * @param {Number} direction
       */
      tick: function (direction) {
        if (![-1, 1].includes(direction)) { console.warn('-1 or 1 expected') }

        return this.$store.commit(
          mutations.SET_DISPLAYED_DATETIME,
          moment(this.displayedDatetime)[direction < 0 ? 'subtract' : 'add'](20, 'seconds').valueOf())
      },

      tickPlaySpeed (direction) {
        console.log(direction)
        if (![-1, 1].includes(direction)) { console.warn('-1 or 1 expected') }

        this.playSpeed = this.playSpeed + (direction < 0 ? -this.SPEED_TICK : this.SPEED_TICK)
      },
    },
  }
</script>

<style scoped>
    .metrocheck-player {
        width: 100%;
    }
</style>
